         
//####################################################################=
//####################################################################=
//                                                                    =
//     FILE:     standarw.h, bc only                                           =
//                                                                    =
//####################################################################=
//####################################################################=


typedef size_t RWFUNC ( void* , size_t , size_t , FILE* );
typedef int (*DBFUNC)( FILE* , RWFUNC );
typedef int (*EDFUNC) ( int );
RWFUNC myfread , myfwrite;

   int fscanfErrorHandle ( int fs );
   int fprintfErrorHandle ( int fp );
   int IsError ( int d );
   int IfExistDirectory ( char * outdirname );

#define INPUTCONTROLVALUE 12345
const int bufclen = 132;
//####################################################################
//####################################################################
//####################################################################
class CONFIG
{
private:
  HINSTANCE hincfg;
  int   ReadWriteFlag;
  int   CompareTemp;
  char bufc[bufclen];
  double  tTempFind;
public:
  char  DataFileName[132];
  char  DatbFileName[132];
  char  DatcFileName[132];
  char  DatdFileName[132];
  char  DateFileName[132];
  char  cfgFileName[64];
  char  RegimeName[64];
  int   nRegime;
  char  ColorsFileName[64];
  char  UserName[32];
  int   Attempt;
  int   NumberBad , NumberGood;
  int   FindBad , FindGood;
  FILE *pConfigFile;

//   int   rwconfig( RWFUNC rwf );
int CONFIG::ioConfig (void);
int CONFIG::ioConfigContents (void);
int CONFIG::ExtractDataFileName ( char * DirName , char * DataName );
private:
// This is the user-defined function:
   int   CONFIG::ioDatas (int numofile = 0);
public:
int CONFIG::SetRegime(int n){nRegime = n; return FALSE;}
int CONFIG::GetRegime(void){return nRegime;}
int   CONFIG::FindMark ( const char* VName );
int   CONFIG::FindMark ( const char* VName , int   i);
int   CONFIG::ReadWriteFunc ( int * d, const char* VName);
int   CONFIG::ReadWriteFunc ( int & d, const char* VName);
int   CONFIG::ReadWriteFunc ( char * d, const char* VName);
int   CONFIG::ReadWriteFunc ( double * d, const char* VName );
int   CONFIG::ReadWriteFunc ( double & d, const char* VName);
int   CONFIG::ReadWriteFunc ( double * d, int i, const char* VName );
int   CONFIG::ReadWriteFunc ( int * d, int i, const char* VName );
void CONFIG::ToReadMode(void) { ReadWriteFlag = TRUE;}
void CONFIG::ToWriteMode(void) { ReadWriteFlag = FALSE;}
BOOL CONFIG::IsReadMode(void) { return ( ReadWriteFlag == TRUE);}
BOOL CONFIG::IsWriteMode(void) { return ( ReadWriteFlag == FALSE);}
BOOL CONFIG::GetReadWriteMode(void) { return ReadWriteFlag;}
BOOL CONFIG::SetReadWriteMode(int n)
   { if (n==TRUE) ToReadMode(); else ToWriteMode(); return TRUE;}

void CONFIG::SetDataFileName(char* dfn){ lstrcpy ( DataFileName, dfn);}
void CONFIG::SetDatbFileName(char* dfn){ lstrcpy ( DatbFileName, dfn);}
void CONFIG::SetDatcFileName(char* dfn){ lstrcpy ( DatcFileName, dfn);}
void CONFIG::SetDatdFileName(char* dfn){ lstrcpy ( DatdFileName, dfn);}
void CONFIG::SetDateFileName(char* dfn){ lstrcpy ( DateFileName, dfn);}
void CONFIG::SetIniFileName(char* dfn) { lstrcpy ( DataFileName, dfn);}

void CONFIG::SetCfgFileName(char* dfn) { lstrcpy ( cfgFileName , dfn);}
void CONFIG::SetRegimeName(char* dfn)  { lstrcpy ( RegimeName , dfn);}
void CONFIG::CopyRegimeName(char* buf) { lstrcpy ( buf, RegimeName);}
void CONFIG::SetColFileName(char* dfn) { lstrcpy ( ColorsFileName , dfn);}
void      CONFIG::SethInstance(HINSTANCE hin){hincfg = hin;}
HINSTANCE CONFIG::GethInstance(void){return hincfg;}
CONFIG::CONFIG()
{
   SetDatbFileName("defdatb.ini");
   SetIniFileName ("defdata.ini");
   SetCfgFileName ("defcfg.ini");
   SetRegimeName  ("DefRegime");
   SetColFileName ("defclr.ini");
   lstrcpy ( UserName , "Ghost_User");
   CompareTemp = TRUE;
   Attempt = 1;
   NumberGood = NumberBad = 0;
   FindGood = FindBad = 0;
   ToReadMode();
}
  int CONFIG::ioData (int numoffile = 0);
};

//####################################################################
#define  SHORT  short
struct FONTMODEL
{
/* my old:
  SHORT Modification;
  SHORT Height;
  SHORT Width;
  SHORT Escapement;
  SHORT Orientation;
  SHORT Weight;
  BYTE  Italic;
  int   CoefFontX;
  int   CoefFontY;
  BYTE * FaceName;
*/
  int Modification;
  int Height;
  int Width;
  int Escapement;
  int Orientation;
  int Weight;
  DWORD  Italic;
  int   CoefFontX;
  int   CoefFontY;
  LPCSTR FaceName;
};


/*
HFONT CreateFont(
    int  nHeight,	// logical height of font
    int  nWidth,	// logical average character width
    int  nEscapement,	// angle of escapement
    int  nOrientation,	// base-line orientation angle
    int  fnWeight,	// font weight
    DWORD  fdwItalic,	// italic attribute flag
    DWORD  fdwUnderline,	// underline attribute flag
    DWORD  fdwStrikeOut,	// strikeout attribute flag
    DWORD  fdwCharSet,	// character set identifier
    DWORD  fdwOutputPrecision,	// output precision
    DWORD  fdwClipPrecision,	// clipping precision
    DWORD  fdwQuality,	// output quality
    DWORD  fdwPitchAndFamily,	// pitch and family
    LPCTSTR  lpszFace 	// address of typeface name string
   );
*/
BOOL ReadFont( FILE * pFile , FONTMODEL & Font , char * Fonm );

double ReadDoubleIni(char* SectName, char* EntryName, double defval, char* fName);
double ReadIntIni(char* SectName, char* EntryName, int defval, char* fName);
COLORREF ReadColorIni(char* SectName, char* EntryName, char* fName);

int wrlog(char* txt);
int crlog(char* txt);

//####################################################################=
//####################################################################=
//                                                                    =
//  ENDFILE:     standarw.h                                           =
//                                                                    =
//####################################################################=
//####################################################################=

